let
set = {
  # adatped from nixpkgs/nixos/modules/services/web-servers/apache-httpd/default.nix
  httpdInte  = import ../websites/httpd-service-builder.nix { httpdName = "Inte"; withUsers = false; };
  httpdProd  = import ../websites/httpd-service-builder.nix { httpdName = "Prod"; withUsers = false; };
  httpdTools = import ../websites/httpd-service-builder.nix { httpdName = "Tools"; withUsers = true; };

  databases  = ./databases;
  mariadb    = ./databases/mariadb.nix;
  openldap   = ./databases/openldap;
  postgresql = ./databases/postgresql.nix;
  redis      = ./databases/redis.nix;
  postgresqlReplication = ./databases/postgresql_replication.nix;
  mariadbReplication = ./databases/mariadb_replication.nix;
  redisReplication = ./databases/redis_replication.nix;
  openldapReplication = ./databases/openldap_replication.nix;

  websites = ./websites;
  atenInte = ./websites/aten/integration.nix;
  atenProd = ./websites/aten/production.nix;
  capitainesProd = ./websites/capitaines/production.nix;
  chloeInte = ./websites/chloe/integration.nix;
  chloeProd = ./websites/chloe/production.nix;
  connexionswingInte = ./websites/connexionswing/integration.nix;
  connexionswingProd = ./websites/connexionswing/production.nix;
  denisejeromeProd = ./websites/denisejerome/production.nix;
  emiliaProd = ./websites/emilia/production.nix;
  florianApp = ./websites/florian/app.nix;
  florianInte = ./websites/florian/integration.nix;
  florianProd = ./websites/florian/production.nix;
  immaeProd = ./websites/immae/production.nix;
  immaeRelease = ./websites/immae/release.nix;
  immaeTemp = ./websites/immae/temp.nix;
  leilaProd = ./websites/leila/production.nix;
  ludivinecassalInte = ./websites/ludivinecassal/integration.nix;
  ludivinecassalProd = ./websites/ludivinecassal/production.nix;
  nassimeProd = ./websites/nassime/production.nix;
  naturaloutilProd = ./websites/naturaloutil/production.nix;
  telioTortayProd = ./websites/teliotortay/production.nix;
  papaSurveillance = ./websites/papa/surveillance.nix;
  piedsjalouxInte = ./websites/piedsjaloux/integration.nix;
  piedsjalouxProd = ./websites/piedsjaloux/production.nix;

  cloudTool = ./websites/tools/cloud;
  davTool = ./websites/tools/dav;
  dbTool = ./websites/tools/db;
  diasporaTool = ./websites/tools/diaspora;
  etherTool = ./websites/tools/ether;
  gitTool = ./websites/tools/git;
  mastodonTool = ./websites/tools/mastodon;
  mgoblinTool = ./websites/tools/mgoblin;
  peertubeTool = ./websites/tools/peertube;
  toolsTool = ./websites/tools/tools;
  mailTool = ./websites/tools/mail;

  mail = ./mail;

  buildbot = ./buildbot;
  certificates = ./certificates.nix;
  gitolite = ./gitolite;
  irc = ./irc.nix;
  pub = ./pub;
  tasks = ./tasks;
  dns = ./dns.nix;
  ftp = ./ftp.nix;
  mpd = ./mpd.nix;
  ssh = ./ssh;
  monitoring = ./monitoring;

  system = ./system.nix;
};
in
builtins.listToAttrs (map (attr: { name = "priv${attr}"; value = set.${attr}; }) (builtins.attrNames set))
